]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Make the --valgrind option useful, (and drop --verbose).
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 # Convenience
53 #
54 # A regexp to match 5 and 40 hexdigits
55 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
56 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
57
58 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
59 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
60
61 # Each test should start with something like this, after copyright notices:
62 #
63 # test_description='Description of this test...
64 # This test checks if command xyzzy does the right thing...
65 # '
66 # . ./test-lib.sh
67 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
68                 TERM=$ORIGINAL_TERM &&
69                 export TERM &&
70                 [ -t 1 ] &&
71                 tput bold >/dev/null 2>&1 &&
72                 tput setaf 1 >/dev/null 2>&1 &&
73                 tput sgr0 >/dev/null 2>&1
74         ) &&
75         color=t
76
77 while test "$#" -ne 0
78 do
79         case "$1" in
80         -d|--d|--de|--deb|--debu|--debug)
81                 debug=t; shift ;;
82         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
83                 immediate=t; shift ;;
84         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
85                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
86         -h|--h|--he|--hel|--help)
87                 help=t; shift ;;
88         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
89                 verbose=t; shift ;;
90         -q|--q|--qu|--qui|--quie|--quiet)
91                 quiet=t; shift ;;
92         --with-dashes)
93                 with_dashes=t; shift ;;
94         --no-color)
95                 color=; shift ;;
96         --no-python)
97                 # noop now...
98                 shift ;;
99         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
100                 valgrind=t; verbose=t; shift ;;
101         --tee)
102                 shift ;; # was handled already
103         --root=*)
104                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
105                 shift ;;
106         *)
107                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
108         esac
109 done
110
111 if test -n "$color"; then
112         say_color () {
113                 (
114                 TERM=$ORIGINAL_TERM
115                 export TERM
116                 case "$1" in
117                         error) tput bold; tput setaf 1;; # bold red
118                         skip)  tput bold; tput setaf 2;; # bold green
119                         pass)  tput setaf 2;;            # green
120                         info)  tput setaf 3;;            # brown
121                         *) test -n "$quiet" && return;;
122                 esac
123                 shift
124                 printf " "
125                 printf "$@"
126                 tput sgr0
127                 )
128         }
129 else
130         say_color() {
131                 test -z "$1" && test -n "$quiet" && return
132                 shift
133                 printf " "
134                 printf "$@"
135         }
136 fi
137
138 error () {
139         say_color error "error: $*"
140         GIT_EXIT_OK=t
141         exit 1
142 }
143
144 say () {
145         say_color info "$*"
146 }
147
148 test "${test_description}" != "" ||
149 error "Test script did not set test_description."
150
151 if test "$help" = "t"
152 then
153         echo "Tests ${test_description}"
154         exit 0
155 fi
156
157 echo "Testing ${test_description}"
158
159 exec 5>&1
160 if test "$verbose" = "t"
161 then
162         exec 4>&2 3>&1
163 else
164         exec 4>/dev/null 3>/dev/null
165 fi
166
167 test_failure=0
168 test_count=0
169 test_fixed=0
170 test_broken=0
171 test_success=0
172
173 die () {
174         code=$?
175         if test -n "$GIT_EXIT_OK"
176         then
177                 exit $code
178         else
179                 echo >&5 "FATAL: Unexpected exit with code $code"
180                 exit 1
181         fi
182 }
183
184 GIT_EXIT_OK=
185 trap 'die' EXIT
186
187 test_decode_color () {
188         sed     -e 's/.\[1m/<WHITE>/g' \
189                 -e 's/.\[31m/<RED>/g' \
190                 -e 's/.\[32m/<GREEN>/g' \
191                 -e 's/.\[33m/<YELLOW>/g' \
192                 -e 's/.\[34m/<BLUE>/g' \
193                 -e 's/.\[35m/<MAGENTA>/g' \
194                 -e 's/.\[36m/<CYAN>/g' \
195                 -e 's/.\[m/<RESET>/g'
196 }
197
198 q_to_nul () {
199         perl -pe 'y/Q/\000/'
200 }
201
202 q_to_cr () {
203         tr Q '\015'
204 }
205
206 append_cr () {
207         sed -e 's/$/Q/' | tr Q '\015'
208 }
209
210 remove_cr () {
211         tr '\015' Q | sed -e 's/Q$//'
212 }
213
214 # Notmuch helper functions
215 increment_mtime_amount=0
216 increment_mtime ()
217 {
218     dir="$1"
219
220     increment_mtime_amount=$((increment_mtime_amount + 1))
221     touch -d "+${increment_mtime_amount} seconds" "$dir"
222 }
223
224 # Generate a new message in the mail directory, with a unique message
225 # ID and subject. The message is not added to the index.
226 #
227 # After this function returns, the filename of the generated message
228 # is available as $gen_msg_filename and the message ID is available as
229 # $gen_msg_id .
230 #
231 # This function supports named parameters with the bash syntax for
232 # assigning a value to an associative array ([name]=value). The
233 # supported parameters are:
234 #
235 #  [dir]=directory/of/choice
236 #
237 #       Generate the message in directory 'directory/of/choice' within
238 #       the mail store. The directory will be created if necessary.
239 #
240 #  [body]=text
241 #
242 #       Text to use as the body of the email message
243 #
244 #  '[from]="Some User <user@example.com>"'
245 #  '[to]="Some User <user@example.com>"'
246 #  '[subject]="Subject of email message"'
247 #  '[date]="RFC 822 Date"'
248 #
249 #       Values for email headers. If not provided, default values will
250 #       be generated instead.
251 #
252 #  '[cc]="Some User <user@example.com>"'
253 #  [reply-to]=some-address
254 #  [in-reply-to]=<message-id>
255 #  [references]=<message-id>
256 #  [content-type]=content-type-specification
257 #  '[header]=full header line, including keyword'
258 #
259 #       Additional values for email headers. If these are not provided
260 #       then the relevant headers will simply not appear in the
261 #       message.
262 #
263 #  '[id]=message-id'
264 #
265 #       Controls the message-id of the created message.
266 gen_msg_cnt=0
267 gen_msg_filename=""
268 gen_msg_id=""
269 generate_message ()
270 {
271     # This is our (bash-specific) magic for doing named parameters
272     local -A template="($@)"
273     local additional_headers
274
275     gen_msg_cnt=$((gen_msg_cnt + 1))
276     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
277
278     if [ -z "${template[id]}" ]; then
279         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
280     else
281         gen_msg_id="${template[id]}"
282     fi
283
284     if [ -z "${template[dir]}" ]; then
285         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
286     else
287         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
288         mkdir -p "$(dirname "$gen_msg_filename")"
289     fi
290
291     if [ -z "${template[body]}" ]; then
292         template[body]="This is just a test message (#${gen_msg_cnt})"
293     fi
294
295     if [ -z "${template[from]}" ]; then
296         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
297     fi
298
299     if [ -z "${template[to]}" ]; then
300         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301     fi
302
303     if [ -z "${template[subject]}" ]; then
304         template[subject]="Test message #${gen_msg_cnt}"
305     fi
306
307     if [ -z "${template[date]}" ]; then
308         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
309     fi
310
311     additional_headers=""
312     if [ ! -z "${template[header]}" ]; then
313         additional_headers="${template[header]}
314 ${additional_headers}"
315     fi
316
317     if [ ! -z "${template[reply-to]}" ]; then
318         additional_headers="Reply-To: ${template[reply-to]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[in-reply-to]}" ]; then
323         additional_headers="In-Reply-To: ${template[in-reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[cc]}" ]; then
328         additional_headers="Cc: ${template[cc]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[references]}" ]; then
333         additional_headers="References: ${template[references]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[content-type]}" ]; then
338         additional_headers="Content-Type: ${template[content-type]}
339 ${additional_headers}"
340     fi
341
342
343 cat <<EOF >"$gen_msg_filename"
344 From: ${template[from]}
345 To: ${template[to]}
346 Message-Id: <${gen_msg_id}>
347 Subject: ${template[subject]}
348 Date: ${template[date]}
349 ${additional_headers}
350 ${template[body]}
351 EOF
352
353     # Ensure that the mtime of the containing directory is updated
354     increment_mtime "$(dirname "${gen_msg_filename}")"
355 }
356
357 # Generate a new message and add it to the index.
358 #
359 # All of the arguments and return values supported by generate_message
360 # are also supported here, so see that function for details.
361 add_message ()
362 {
363     generate_message "$@" &&
364     notmuch new > /dev/null
365 }
366
367 test_begin_subtest ()
368 {
369     test_subtest_name="$1"
370 }
371
372 # Pass test if two arguments match
373 #
374 # Note: Unlike all other test_expect_* functions, this function does
375 # not accept a test name. Instead, the caller should call
376 # test_begin_subtest before calling this function in order to set the
377 # name.
378 test_expect_equal ()
379 {
380         test "$#" = 3 && { prereq=$1; shift; } || prereq=
381         test "$#" = 2 ||
382         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
383
384         output="$1"
385         expected="$2"
386         if ! test_skip "$@"
387         then
388                 if [ "$output" = "$expected" ]; then
389                         test_ok_ "$test_subtest_name"
390                 else
391                         testname=$this_test.$test_count
392                         echo "$expected" > $testname.expected
393                         echo "$output" > $testname.output
394                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
395                 fi
396     fi
397 }
398
399 TEST_DIR=$(pwd)/test.$$
400 MAIL_DIR=${TEST_DIR}/mail
401 export NOTMUCH_CONFIG=${TEST_DIR}/notmuch-config
402 NOTMUCH=notmuch
403
404 NOTMUCH_NEW ()
405 {
406     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
407 }
408
409 notmuch_search_sanitize ()
410 {
411     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
412 }
413
414 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
415 notmuch_show_sanitize ()
416 {
417     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
418 }
419
420 # End of notmuch helper functions
421
422 # Use test_set_prereq to tell that a particular prerequisite is available.
423 # The prerequisite can later be checked for in two ways:
424 #
425 # - Explicitly using test_have_prereq.
426 #
427 # - Implicitly by specifying the prerequisite tag in the calls to
428 #   test_expect_{success,failure,code}.
429 #
430 # The single parameter is the prerequisite tag (a simple word, in all
431 # capital letters by convention).
432
433 test_set_prereq () {
434         satisfied="$satisfied$1 "
435 }
436 satisfied=" "
437
438 test_have_prereq () {
439         case $satisfied in
440         *" $1 "*)
441                 : yes, have it ;;
442         *)
443                 ! : nope ;;
444         esac
445 }
446
447 # You are not expected to call test_ok_ and test_failure_ directly, use
448 # the text_expect_* functions instead.
449
450 test_ok_ () {
451         test_success=$(($test_success + 1))
452         say_color pass "%-6s" "PASS"
453         echo " $@"
454 }
455
456 test_failure_ () {
457         test_failure=$(($test_failure + 1))
458         say_color error "%-6s" "FAIL"
459         echo " $1"
460         shift
461         echo "$@" | sed -e 's/^/        /'
462         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
463 }
464
465 test_known_broken_ok_ () {
466         test_fixed=$(($test_fixed+1))
467         say_color pass "%-6s" "FIXED"
468         echo " $@"
469 }
470
471 test_known_broken_failure_ () {
472         test_broken=$(($test_broken+1))
473         say_color pass "%-6s" "BROKEN"
474         echo " $@"
475 }
476
477 test_debug () {
478         test "$debug" = "" || eval "$1"
479 }
480
481 test_run_ () {
482         test_cleanup=:
483         eval >&3 2>&4 "$1"
484         eval_ret=$?
485         eval >&3 2>&4 "$test_cleanup"
486         return 0
487 }
488
489 test_skip () {
490         test_count=$(($test_count+1))
491         to_skip=
492         for skp in $NOTMUCH_SKIP_TESTS
493         do
494                 case $this_test.$test_count in
495                 $skp)
496                         to_skip=t
497                 esac
498         done
499         if test -z "$to_skip" && test -n "$prereq" &&
500            ! test_have_prereq "$prereq"
501         then
502                 to_skip=t
503         fi
504         case "$to_skip" in
505         t)
506                 say_color skip >&3 "skipping test: $@"
507                 say_color skip "%-6s" "SKIP"
508                 echo " $1"
509                 : true
510                 ;;
511         *)
512                 false
513                 ;;
514         esac
515 }
516
517 test_expect_failure () {
518         test "$#" = 3 && { prereq=$1; shift; } || prereq=
519         test "$#" = 2 ||
520         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
521         if ! test_skip "$@"
522         then
523                 test_run_ "$2"
524                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
525                 then
526                         test_known_broken_ok_ "$1"
527                 else
528                         test_known_broken_failure_ "$1"
529                 fi
530         fi
531 }
532
533 test_expect_success () {
534         test "$#" = 3 && { prereq=$1; shift; } || prereq=
535         test "$#" = 2 ||
536         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
537         if ! test_skip "$@"
538         then
539                 test_run_ "$2"
540                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
541                 then
542                         test_ok_ "$1"
543                 else
544                         test_failure_ "$@"
545                 fi
546         fi
547 }
548
549 test_expect_code () {
550         test "$#" = 4 && { prereq=$1; shift; } || prereq=
551         test "$#" = 3 ||
552         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
553         if ! test_skip "$@"
554         then
555                 test_run_ "$3"
556                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
557                 then
558                         test_ok_ "$2"
559                 else
560                         test_failure_ "$@"
561                 fi
562         fi
563 }
564
565 # test_external runs external test scripts that provide continuous
566 # test output about their progress, and succeeds/fails on
567 # zero/non-zero exit code.  It outputs the test output on stdout even
568 # in non-verbose mode, and announces the external script with "* run
569 # <n>: ..." before running it.  When providing relative paths, keep in
570 # mind that all scripts run in "trash directory".
571 # Usage: test_external description command arguments...
572 # Example: test_external 'Perl API' perl ../path/to/test.pl
573 test_external () {
574         test "$#" = 4 && { prereq=$1; shift; } || prereq=
575         test "$#" = 3 ||
576         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
577         descr="$1"
578         shift
579         if ! test_skip "$descr" "$@"
580         then
581                 # Announce the script to reduce confusion about the
582                 # test output that follows.
583                 say_color "" " run $test_count: $descr ($*)"
584                 # Run command; redirect its stderr to &4 as in
585                 # test_run_, but keep its stdout on our stdout even in
586                 # non-verbose mode.
587                 "$@" 2>&4
588                 if [ "$?" = 0 ]
589                 then
590                         test_ok_ "$descr"
591                 else
592                         test_failure_ "$descr" "$@"
593                 fi
594         fi
595 }
596
597 # Like test_external, but in addition tests that the command generated
598 # no output on stderr.
599 test_external_without_stderr () {
600         # The temporary file has no (and must have no) security
601         # implications.
602         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
603         stderr="$tmp/git-external-stderr.$$.tmp"
604         test_external "$@" 4> "$stderr"
605         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
606         descr="no stderr: $1"
607         shift
608         if [ ! -s "$stderr" ]; then
609                 rm "$stderr"
610                 test_ok_ "$descr"
611         else
612                 if [ "$verbose" = t ]; then
613                         output=`echo; echo Stderr is:; cat "$stderr"`
614                 else
615                         output=
616                 fi
617                 # rm first in case test_failure exits.
618                 rm "$stderr"
619                 test_failure_ "$descr" "$@" "$output"
620         fi
621 }
622
623 # This is not among top-level (test_expect_success | test_expect_failure)
624 # but is a prefix that can be used in the test script, like:
625 #
626 #       test_expect_success 'complain and die' '
627 #           do something &&
628 #           do something else &&
629 #           test_must_fail git checkout ../outerspace
630 #       '
631 #
632 # Writing this as "! git checkout ../outerspace" is wrong, because
633 # the failure could be due to a segv.  We want a controlled failure.
634
635 test_must_fail () {
636         "$@"
637         test $? -gt 0 -a $? -le 129 -o $? -gt 192
638 }
639
640 # test_cmp is a helper function to compare actual and expected output.
641 # You can use it like:
642 #
643 #       test_expect_success 'foo works' '
644 #               echo expected >expected &&
645 #               foo >actual &&
646 #               test_cmp expected actual
647 #       '
648 #
649 # This could be written as either "cmp" or "diff -u", but:
650 # - cmp's output is not nearly as easy to read as diff -u
651 # - not all diff versions understand "-u"
652
653 test_cmp() {
654         $GIT_TEST_CMP "$@"
655 }
656
657 # This function can be used to schedule some commands to be run
658 # unconditionally at the end of the test to restore sanity:
659 #
660 #       test_expect_success 'test core.capslock' '
661 #               git config core.capslock true &&
662 #               test_when_finished "git config --unset core.capslock" &&
663 #               hello world
664 #       '
665 #
666 # That would be roughly equivalent to
667 #
668 #       test_expect_success 'test core.capslock' '
669 #               git config core.capslock true &&
670 #               hello world
671 #               git config --unset core.capslock
672 #       '
673 #
674 # except that the greeting and config --unset must both succeed for
675 # the test to pass.
676
677 test_when_finished () {
678         test_cleanup="{ $*
679                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
680 }
681
682 test_done () {
683         GIT_EXIT_OK=t
684         test_results_dir="$TEST_DIRECTORY/test-results"
685         mkdir -p "$test_results_dir"
686         test_results_path="$test_results_dir/${0%.sh}-$$"
687
688         echo "total $test_count" >> $test_results_path
689         echo "success $test_success" >> $test_results_path
690         echo "fixed $test_fixed" >> $test_results_path
691         echo "broken $test_broken" >> $test_results_path
692         echo "failed $test_failure" >> $test_results_path
693         echo "" >> $test_results_path
694
695         echo
696
697         if [ "$test_failure" = "0" ]; then
698             rm -rf "$remove_tmp"
699             exit 0
700         else
701             exit 1
702         fi
703 }
704
705 find_notmuch_path ()
706 {
707     dir="$1"
708
709     while [ -n "$dir" ]; do
710         bin="$dir/notmuch"
711         if [ -x "$bin" ]; then
712             echo "$dir"
713             return
714         fi
715         dir="$(dirname "$dir")"
716         if [ "$dir" = "/" ]; then
717             break
718         fi
719     done
720 }
721
722 # Test the binaries we have just built.  The tests are kept in
723 # test/ subdirectory and are run in 'trash directory' subdirectory.
724 TEST_DIRECTORY=$(pwd)
725 if test -n "$valgrind"
726 then
727         make_symlink () {
728                 test -h "$2" &&
729                 test "$1" = "$(readlink "$2")" || {
730                         # be super paranoid
731                         if mkdir "$2".lock
732                         then
733                                 rm -f "$2" &&
734                                 ln -s "$1" "$2" &&
735                                 rm -r "$2".lock
736                         else
737                                 while test -d "$2".lock
738                                 do
739                                         say "Waiting for lock on $2."
740                                         sleep 1
741                                 done
742                         fi
743                 }
744         }
745
746         make_valgrind_symlink () {
747                 # handle only executables
748                 test -x "$1" || return
749
750                 base=$(basename "$1")
751                 symlink_target=$TEST_DIRECTORY/../$base
752                 # do not override scripts
753                 if test -x "$symlink_target" &&
754                     test ! -d "$symlink_target" &&
755                     test "#!" != "$(head -c 2 < "$symlink_target")"
756                 then
757                         symlink_target=../valgrind.sh
758                 fi
759                 case "$base" in
760                 *.sh|*.perl)
761                         symlink_target=../unprocessed-script
762                 esac
763                 # create the link, or replace it if it is out of date
764                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
765         }
766
767         # override notmuch executable in TEST_DIRECTORY/..
768         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
769         mkdir -p "$GIT_VALGRIND"/bin
770         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
771         OLDIFS=$IFS
772         IFS=:
773         for path in $PATH
774         do
775                 ls "$path"/notmuch 2> /dev/null |
776                 while read file
777                 do
778                         make_valgrind_symlink "$file"
779                 done
780         done
781         IFS=$OLDIFS
782         PATH=$GIT_VALGRIND/bin:$PATH
783         GIT_EXEC_PATH=$GIT_VALGRIND/bin
784         export GIT_VALGRIND
785 else # normal case
786         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
787         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
788 fi
789 export PATH
790
791 # Test repository
792 test="tmp.$(basename "$0" .sh)"
793 test -n "$root" && test="$root/$test"
794 case "$test" in
795 /*) TMP_DIRECTORY="$test" ;;
796  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
797 esac
798 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
799 rm -fr "$test" || {
800         GIT_EXIT_OK=t
801         echo >&5 "FATAL: Cannot prepare test area"
802         exit 1
803 }
804
805 MAIL_DIR="${TMP_DIRECTORY}/mail"
806 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
807
808 mkdir -p "${test}"
809 mkdir "$MAIL_DIR"
810
811 cat <<EOF >"${NOTMUCH_CONFIG}"
812 [database]
813 path=${MAIL_DIR}
814
815 [user]
816 name=Notmuch Test Suite
817 primary_email=test_suite@notmuchmail.org
818 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
819 EOF
820
821
822 # Use -P to resolve symlinks in our working directory so that the cwd
823 # in subprocesses like git equals our $PWD (for pathname comparisons).
824 cd -P "$test" || error "Cannot setup test environment"
825
826 this_test=${0##*/}
827 this_test=${this_test%%-*}
828 for skp in $NOTMUCH_SKIP_TESTS
829 do
830         to_skip=
831         for skp in $NOTMUCH_SKIP_TESTS
832         do
833                 case "$this_test" in
834                 $skp)
835                         to_skip=t
836                 esac
837         done
838         case "$to_skip" in
839         t)
840                 say_color skip >&3 "skipping test $this_test altogether"
841                 say_color skip "skip all tests in $this_test"
842                 test_done
843         esac
844 done
845
846 # Provide an implementation of the 'yes' utility
847 yes () {
848         if test $# = 0
849         then
850                 y=y
851         else
852                 y="$*"
853         fi
854
855         while echo "$y"
856         do
857                 :
858         done
859 }
860
861 # Fix some commands on Windows
862 case $(uname -s) in
863 *MINGW*)
864         # Windows has its own (incompatible) sort and find
865         sort () {
866                 /usr/bin/sort "$@"
867         }
868         find () {
869                 /usr/bin/find "$@"
870         }
871         sum () {
872                 md5sum "$@"
873         }
874         # git sees Windows-style pwd
875         pwd () {
876                 builtin pwd -W
877         }
878         # no POSIX permissions
879         # backslashes in pathspec are converted to '/'
880         # exec does not inherit the PID
881         ;;
882 *)
883         test_set_prereq POSIXPERM
884         test_set_prereq BSLASHPSPEC
885         test_set_prereq EXECKEEPSPID
886         ;;
887 esac
888
889 test -z "$NO_PERL" && test_set_prereq PERL
890 test -z "$NO_PYTHON" && test_set_prereq PYTHON
891
892 # test whether the filesystem supports symbolic links
893 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
894 rm -f y